PROGRAM AFC1BF
! *** EXAMPLE OF ZFC1FB AND ZFC1BF ***
IMPLICIT DOUBLE PRECISION (A-H,O-Z)
COMPLEX*8,ALLOCATABLE :: C(:)
INTEGER*8 plan

include 'fftw3.f'

! **** INPUT ****
IERR=0
READ(5,*) N
ALLOCATE(C(N))
READ(5,*) (C(I),I=1,N)
WRITE(6,1000) N,N
WRITE(6,2000)
WRITE(6,2100) (I,REAL(C(I)),I,AIMAG(C(I)),I=1,N)
! **** OUTPUT ****
WRITE(6,1100)
! **** FORWARD TRANSFORM ****
CALL SFFTW_PLAN_DFT_1D(plan,N,C,C,FFTW_FORWARD,FFTW_ESTIMATE)
CALL SFFTW_EXECUTE(plan)
CALL SFFTW_DESTROY_PLAN(plan)
! **** NORMALIZATION ****
DO 20 I = 1,N
C(I) = C(I)/REAL(N)
20 CONTINUE
WRITE(6,1200)
WRITE(6,1400) IERR
WRITE(6,2000)
WRITE(6,2100) (I,REAL(C(I)),I,AIMAG(C(I)),I=1,N)
! **** BACKWARD TRANSFORM ****
CALL SFFTW_PLAN_DFT_1D(plan,0,C,C,FFTW_BACKWARD,FFTW_ESTIMATE)
CALL SFFTW_EXECUTE(plan)
CALL SFFTW_DESTROY_PLAN(plan)
WRITE(6,1300)
WRITE(6,1400) IERR
WRITE(6,2000)
WRITE(6,2100) (I,REAL(C(I)),I,AIMAG(C(I)),I=1,N)
CALL DFFTW_CLEANUP()
STOP
! **** FORMAT ****
1000 FORMAT(1X,'*** ZFC1FB AND ZFC1BF ***'// &
 1X,' ** INPUT **'// &
 1X,' LD = ',I2// &
 1X,' INPUT DATA'// &
 1X,' N = ',I2/)
1100 FORMAT(//1X,' ** OUTPUT **')
1200 FORMAT(/5X,'( FORWARD TRANSFORM )'/)
1300 FORMAT(/5X,'( BACKWARD TRANSFORM )'/)
1400 FORMAT(5X,'IERR = ',I5// &
 5X,'SOLUTION'/)
2000 FORMAT(7X,'REAL PART',16X,'IMAGINARY PART')
2100 FORMAT(7X,' C(',I2,') = ',F9.5,6X,' C(',I2,') = ',F9.5)
END
