PROGRAM AFC3BF
! *** EXAMPLE OF ZFC3FB AND ZFC3BF ***
PARAMETER (NX=5,NY=4,NZ=3,LX=5,LY=4,LZ=3)
COMPLEX*16 C1(LX,LY,LZ),C2(LX,LY,LZ),C3(LX,LY,LZ)
INTEGER*8 plan

include 'fftw3.f'

! **** INPUT ****
IERR=0
DO 30 K=1,NZ
DO 20 J=1,NY
DO 10 I=1,NX
C1(I,J,K)=DCMPLX( DBLE(NX+NY+NZ)/DBLE(I+J+K), &
 DBLE(I*J*K)/DBLE(NX*NY*NZ) )
10 CONTINUE
20 CONTINUE
30 CONTINUE
WRITE(6,1000)
WRITE(6,1010) NX,NY,NZ,LX,LY,LZ
DO 100 K=1,NZ
WRITE(6,1020) K,((C1(I,J,K),J=1,NY),I=1,NX)
100 CONTINUE
! **** OUTPUT ****
WRITE(6,1030)
! **** INITIALIZATION + FORWARD TRANSFORM ****
CALL DFFTW_PLAN_DFT_3D(plan,NX,NY,NZ,C1,C2,FFTW_FORWARD,FFTW_ESTIMATE)
CALL DFFTW_EXECUTE(plan)
CALL DFFTW_DESTROY_PLAN(plan)
! **** NORMALIZATION ****
DO 60 K=1,NZ
DO 50 J=1,NY
DO 40 I=1,NX
C2(I,J,K)=C2(I,J,K)/DBLE(NX*NY*NZ)
40 CONTINUE
50 CONTINUE
60 CONTINUE
WRITE(6,1040) IERR
DO 200 K=1,NZ
WRITE(6,1020) K,((C2(I,J,K),J=1,NY),I=1,NX)
200 CONTINUE
! **** BACKWARD TRANSFORM ****
CALL DFFTW_PLAN_DFT_3D(plan,NX,NY,NZ,C2,C3,FFTW_BACKWARD,FFTW_ESTIMATE)
CALL DFFTW_EXECUTE(plan)
CALL DFFTW_DESTROY_PLAN(plan)
WRITE(6,1050) IERR
DO 300 K=1,NZ
WRITE(6,1020) K,((C3(I,J,K),J=1,NY),I=1,NX)
300 CONTINUE
CALL DFFTW_CLEANUP()
STOP
! **** FORMAT ****
1000 FORMAT(1X,'*** ZFC3FB AND ZFC3BF ***'// &
 1X,' ** INPUT **'/)
1010 FORMAT(1X,' NX =',I3,' NY =',I3,' NZ =',I3/ &
 1X,' LX =',I3,' LY =',I3,' LZ =',I3 )
1020 FORMAT(/1X,' C(IX,IY,',I2,')', &
 /4(1X,' (',F6.3,',',F6.3,')'))
1030 FORMAT(/1X,' ** OUTPUT **')
1040 FORMAT(/1X,' ( FORWARD TRANSFORM )'//4X,'IERR =',I6)
1050 FORMAT(/1X,' ( BACKWARD TRANSFORM )'//4X,'IERR =',I6)
END
