/**
 * \license This project is released under the BSD 2-clause license
 *
 * Copyright (C) 2014 Xevolver Project. All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * - Redistributions of source code must retain the above copyright
 *   notice, this list of conditions and the following disclaimer.
 *
 * - Redistributions in binary form must reproduce the above copyright
 *   notice, this list of conditions and the following disclaimer in
 *   the documentation and/or other materials provided with the
 *   distribution.
 *    
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 */
/* 桼ƥƥؿ */

#include <stdio.h>
#include <stdlib.h>

#ifndef FFTW_ASL_INCLUDED
#include "fftw_asl.h"
#endif

Int32 __FFTWR_fftw_to_asl_flag(Int32 fftw_flag)
{
  if (fftw_flag == -1)
  {
    return 1;
  }
  else
  {
    return -1;
  }
}

void __FFTWR_check_asl_error(Int32 asl_err)
{
  switch (asl_err)
  {
    case 0 :
    case 1000 :
      /* NO ERROR */
      return ;
    case 3000 :
      /* ERROR : N <= 1 */
      fprintf(stderr, "The size of the transform is invalid\n");
      exit(1) ;
    case 3010 :
      /* ERROR : N > LD */
      /* Υˤãʤ */
      fprintf(stderr, "Internal Error : The size of the transform is smaller than that of the array\n");
      exit(1) ;
    case 3020 :
      /* ERROR : ISW != 0,-1,1 */
      /* Υˤãʤ */
      fprintf(stderr, "Internal Error : Illegal SIGN\n");
      exit(1) ;
    default :
      fprintf(stderr, "Internal Error : Illegal ASL ERROR\n");
      exit(1) ;
  }
}
