/* C interface example for ASL_zfc1fb , ASL_zfc1bf */
#include <stdio.h>
#include <stdlib.h>
#include "mkl_dfti.h"
int main()
{
  int ld=16;
  int n;
  MKL_Complex16 *c;
  int i;
  FILE *fp;
  DFTI_DESCRIPTOR *my_desc1_handle;
  long status;

  fp = fopen( "1d.dat", "r" );
  if( fp == NULL )
  {
    printf( "file open error\n" );
    return -1;
  }

  printf( " *** ASL_zfc1fb , ASL_zfc1bf ***\n" );
  printf( "\n ** Input **\n\n" );

  c = malloc((size_t)( sizeof(MKL_Complex16) * ld ));

  if( c == NULL )
  {
    printf( "no enough memory for array c\n" );
    return -1;
  }

  fscanf( fp, "%d", &n );
  for( i=0 ; i<n ; i++ )
  {
    fscanf( fp, "%lf%lf", &c[i].real, &c[i].imag );
  }
  printf( "\t Real Part Imaginary Part\n" );
  for( i=0 ; i<n ; i++ )
  {
    printf( "\t c[%3d].r = %8.3g c[%3d].i = %8.3g\n", i, c[i].real, i, c[i].imag );
  }
  fclose( fp );

  printf( "\n ** Output **\n" );
  status=DftiCreateDescriptor( &my_desc1_handle, DFTI_DOUBLE, DFTI_COMPLEX, 0, ld);
  status=DftiCommitDescriptor( my_desc1_handle );
  status=DftiComputeForward( my_desc1_handle, c);
  printf("forward bad_desc =%ld\n",status);
  status=DftiFreeDescriptor( &my_desc1_handle );

  for( i=0 ; i<n ; i++ )
  {
    c[i].real /= n;
    c[i].imag /= n;
  }

  printf( "\n\t< Forward Transform >\n" );
  printf( "\n\tSolution\n\n" );
  printf( "\t Real Part Imaginary Part\n" );
  for( i=0 ; i<n ; i++ )
  {
    printf( "\t c[%3d].r = %8.3g c[%3d].i = %8.3g\n", i, c[i].real, i, c[i].imag );
  }

  status=DftiCreateDescriptor( &my_desc1_handle, DFTI_DOUBLE, DFTI_COMPLEX, 0, ld);
  status=DftiCommitDescriptor( my_desc1_handle );
  status=DftiComputeBackward( my_desc1_handle, c);
  printf("backward bad_desc =%ld\n",status);
  status=DftiFreeDescriptor( &my_desc1_handle );

  printf( "\n\t< Backward Transform >\n" );
  printf( "\n\tSolution\n\n" );
  printf( "\t Real Part Imaginary Part\n" );
  for( i=0 ; i<n ; i++ )
  {
    printf( "\t c[%3d].r = %8.3g c[%3d].i = %8.3g\n", i, c[i].real, i, c[i].imag );
  }

  free(c);

  return 0;
}
