PROGRAM AFC2BF
use MKL_DFTI
! *** EXAMPLE OF ZFC2FB AND ZFC2BF ***
PARAMETER (NX=5,NY=4,LX=5,LY=4)
COMPLEX*16 C(LX,LY),CE(LX*LY)
type(DFTI_DESCRIPTOR), POINTER :: My_Desc1_Handle
INTEGER NUM(2)
INTEGER status
Equivalence (C,CE)

NUM(1)=NX
NUM(2)=NY
! **** INPUT ****
IERR=0
DO 20 J=1,NY
DO 10 I=1,NX
C(I,J)= DCMPLX(DBLE(I+J), DBLE(I*J)/DBLE(NX*NY))
10 CONTINUE
20 CONTINUE
WRITE(6,1000)
WRITE(6,1010) NX,NY,LX,LY
WRITE(6,1020)
WRITE(6,1030) ((C(I,J),J=1,NY),I=1,NX)
! **** OUTPUT ****
WRITE(6,1040)
! **** INITIALIZATION + FORWARD TRANSFORM ****
status=DftiCreateDescriptor(My_Desc1_Handle,DFTI_DOUBLE,DFTI_COMPLEX,2,NUM)
status=DftiCommitDescriptor(My_Desc1_Handle)
status=DftiComputeForward(My_Desc1_Handle,CE)
status=DftiFreeDescriptor(My_Desc1_Handle)
! **** NORMALIZATION ****
DO 40 J=1,NY
DO 30 I=1,NX
C(I,J)=C(I,J)/DBLE(NX*NY)
30 CONTINUE
40 CONTINUE
WRITE(6,1050) IERR
WRITE(6,1020)
WRITE(6,1030) ((C(I,J),J=1,NY),I=1,NX)
! **** BACKWARD TRANSFORM ****
status=DftiCreateDescriptor(My_Desc1_Handle,DFTI_DOUBLE,DFTI_COMPLEX,2,NUM)
status=DftiCommitDescriptor(My_Desc1_Handle)
status=DftiComputeBackward(My_Desc1_Handle,CE)
status=DftiFreeDescriptor(My_Desc1_Handle)
WRITE(6,1060) IERR
WRITE(6,1020)
WRITE(6,1030) ((C(I,J),J=1,NY),I=1,NX)
STOP
!
! **** FORMAT ****
!
1000 FORMAT(1X,'*** ZFC2FB AND ZFC2BF ***'// &
 1X,' ** INPUT **'/)
1010 FORMAT(1X,' NX =',I3,' NY =',I3/ &
 1X,' LX =',I3,' LY =',I3/)
1020 FORMAT(1X,' C(IX,IY)')
1030 FORMAT(4(1X,' (',F6.3,',',F6.3,')'))
1040 FORMAT(/1X,' ** OUTPUT **')
1050 FORMAT(/1X,' ( FORWARD TRANSFORM )'/ &
 /1X,' IERR =',I4/)
1060 FORMAT(/1X,' ( BACKWARD TRANSFORM )'/ &
 /1X,' IERR =',I4/)
END
