/**
 * \license This project is released under the BSD 2-clause license
 *
 * Copyright (C) 2014 Xevolver Project. All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * - Redistributions of source code must retain the above copyright
 *   notice, this list of conditions and the following disclaimer.
 *
 * - Redistributions in binary form must reproduce the above copyright
 *   notice, this list of conditions and the following disclaimer in
 *   the documentation and/or other materials provided with the
 *   distribution.
 *    
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#define MKL_ASLI64_INCLUDED

#ifndef MKL_ASL_INCLUDED
#include "mkl_asl.h"
#endif

struct MKL2ASL_DESCRIPTOR_D  /* ѥǥץǡ¤ */
{
  Int32  commit_flag;     /* ǥץcommitƤ뤫 */
  Int32  precision;       /*  */
  Int32  domain;          /*  */
  Int64  dim;             /*  */
  Int64  len_1d;          /* 1ܤѴǿ */
  Int64 *length;          /* Ѵǿ */
  Int32  placement_flag;  /* ϤϤ˾񤭤뤫 */
};

/* ASLؿEXTERN */
/* C */
/* ʣ1ΥաꥨѴ */
extern Int64 ASL_Lcfc1fb(Int64, Complex8 *, Int64, Int64, Int64 *,
                         float *, Complex8 *);
extern Int64 ASL_Lzfc1fb(Int64, Complex16 *, Int64, Int64, Int64 *,
                         double *, Complex16 *);
/* ʣ2ΥաꥨѴ */
extern Int64 ASL_Lcfc2fb(Int64, Int64, Complex8 *, Int64, Int64, Int64,
                         Int64 *, float *, Complex8 *);
extern Int64 ASL_Lzfc2fb(Int64, Int64, Complex16 *, Int64, Int64, Int64,
                         Int64 *, double *, Complex16 *);
/* ʣ3ΥաꥨѴ */
extern Int64 ASL_Lcfc3fb(Int64, Int64, Int64, Complex8 *, Int64, Int64,
                         Int64, Int64, Int64 *, float *, Complex8 *);
extern Int64 ASL_Lzfc3fb(Int64, Int64, Int64, Complex16 *, Int64, Int64,
                         Int64, Int64, Int64 *, double *, Complex16 *);
/* ASLؿEXTERNޤ */
